/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	AICCLogForCSV
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.util;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import jp.co.ntt.lms.lo.scorm.kernel.exception.SystemException;

import org.xml.sax.SAXException;

/**
 *	AICCLogForCSV クラス<br>
 *	CSV形式のAOCCLogの具象クラス<br>
 */
public class AICCLogForCSV {
	/**
	 * タイトル行のHashMap。キーはStringでタイトル名、
	 * 値には Integerで列番号が格納される
	 */
	private HashMap title;

	/** データ行のArrayList。String[]で行のデータが格納される */
	private ArrayList data;

	/** ArrayListからString[]へ変換する際に使用するconst値 */
	private static String[] _toArray = new String[0];

	/**
	 * デフォルトコンストラクタ
	 */
	public AICCLogForCSV() {}

	/**
	 * 指定されたCSV形式のAICCログファイルを読み込み、初期化を行う。<br>
	 * ファイルを一行ずつ読み込み、タイトル行(1行目)とデータ行(2行目以降)
	 * に分割を行い、それぞれ、HashMap titleおよびArrayList dataへ格納する。<br>
	 * titleはキーにタイトル名、値に該当タイトルの列番号をIntegerで格納する<br>
	 * dataはHashMapString[]型の配列で、カンマで分割されたデータが一行毎に格納される<br>
	 *
	 * @param filename	CSV形式のAICCログファイル名を指定する
	 */
	public void initialize(String filename)
		throws
			UnsupportedEncodingException,
			FileNotFoundException,
			IOException,
			ParserConfigurationException,
			SAXException,
			TransformerException,
			SystemException {

		String encoding = SG.get("LearningLogEncoding");

		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));

		try {
			String line = br.readLine();

			if (line == null) {
				throw new SystemException(filename + " is no title line");
			}

			String[] _title = separate(line, 1, encoding);

			title = new HashMap(_title.length);

			for (int i = 0; i < _title.length; i++) {
				title.put(_title[i], new Integer(i));
			}

			data = new ArrayList();

			for (int lineNumber = 2;; lineNumber++) {
				line = br.readLine();

				if (line == null) {
					break;
				}

				String[] _data = separate(line, lineNumber, encoding);

				if (_data.length != title.size()) {
					throw new SystemException(
						line + "(" + lineNumber + ") [" + _data.length + ", " + title.size() + "]");
				}

				data.add(_data);
			}
		}
		finally {
			br.close();
		}
	}

	/**
	 * lineで指定された文字列を,で分割する。<br><br>
	 * 1. ,と,項目間は"で囲まれている事<br>
	 * 2. "を項目に設定する場合は""でエスケープされている事<br>
	 *
	 * @param	line	CSV形式の文字列
	 * @return	,で分割された文字列の配列を返却する
	 */
	private String[] separate(String line, int lineNumber, String encoding)
		throws SystemException, UnsupportedEncodingException {
		StringBuffer sb = new StringBuffer();
		ArrayList list = new ArrayList();

		int max = line.length();

		int status = 0;

		for (int i = 0; i < max; i++) {

			switch (status) {
				case 0 : /* check current position is (initial) " */

					if (line.charAt(i) != '\"') {
						throw new SystemException(
							line + "(" + lineNumber + ") - " + i + ":(" + (char)line.charAt(i) + ")");
					}

					status++;
					break;

				case 1 : /* find terminate " */
					if (line.charAt(i) == '\"') {

						if (i + 1 >= max) {
							status++;
							break;
						}

						if (line.charAt(i + 1) != '\"') {
							status++;
							break;
						}

						i++;
					}

					sb.append(line.charAt(i));
					break;

				case 2 : /* check current position is , */
					if (line.charAt(i) != ',') {
						throw new SystemException(
							line + "(" + lineNumber + ") - " + i + ":(" + (char)line.charAt(i) + ")");
					}

					list.add(URLDecoder.decode(sb.toString(), encoding));

					sb = new StringBuffer();

					status = 0;
					break;
			}
		}

		if (status != 2) {
			throw new SystemException(line + "(" + lineNumber + ") - status = " + status);
		}

		list.add(URLDecoder.decode(sb.toString(), encoding));

		return (String[])list.toArray(_toArray);
	}

	/**
	 * タイトルの列を取得する
	 *
	 * @param	name	タイトル名を指定する
	 * @return	列
	 */
	public int index(String name) {
		return ((Integer)title.get(name)).intValue();
	}

	/**
	 * データの行数を取得する
	 *
	 * @return	データの行数
	 */
	public int size() {
		return data.size();
	}

	/**
	 * indexで指定された行のデータを取得する
	 *
	 * @param	row	行番頭
	 * @return	該当列のデータをString[]で返却する
	 */
	public String[] get(int row) {
		return (String[])data.get(row);
	}

	/**
	 * 指定された列、行のデータを取得する
	 *
	 * @param	row		行番号を指定する
	 * @param	column	列を指定する
	 * @return	該当行、列のデータを返却する
	 */
	public String get(int row, int column) {
		return get(row)[column];
	}

	/**
	 * 指定された列、行のデータを取得する
	 *
	 * @param	title	タイトル名を指定する
	 * @param	row		行番号を指定する
	 * @return 該当行の該当タイトル名の列のデータを返却する
	 */
	public String get(String title, int row) {
		return get(row)[index(title)];
	}
}
